osg::AtomicCounterBufferObject Class Reference

`#include <BufferObject>`

Inheritance diagram for osg::AtomicCounterBufferObject:

## Public Member Functions

| AtomicCounterBufferObject ()
| AtomicCounterBufferObject (const AtomicCounterBufferObject &ubo, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Object (osg, AtomicCounterBufferObject)
Public Member Functions inherited from osg::BufferObject
| BufferObject ()
| BufferObject (const BufferObject &bo, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
void | setTarget (GLenum target)
GLenum | getTarget () const
void | setUsage (GLenum usage)
GLenum | getUsage () const
BufferObjectProfile & | getProfile ()
const BufferObjectProfile & | getProfile () const
void | setCopyDataAndReleaseGLBufferObject (bool copyAndRelease)
bool | getCopyDataAndReleaseGLBufferObject () const
void | dirty ()
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
void | releaseGLObjects (State *state=0) const
unsigned int | addBufferData (BufferData *bd)
void | removeBufferData (unsigned int index)
void | removeBufferData (BufferData *bd)
void | setBufferData (unsigned int index, BufferData *bd)
BufferData * | getBufferData (unsigned int index)
const BufferData * | getBufferData (unsigned int index) const
unsigned int | getNumBufferData () const
void | setGLBufferObject (unsigned int contextID, GLBufferObject *glbo)
GLBufferObject * | getGLBufferObject (unsigned int contextID) const
GLBufferObject * | getOrCreateGLBufferObject (unsigned int contextID) const
unsigned int | computeRequiredBufferSize () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~AtomicCounterBufferObject ()
Protected Member Functions inherited from osg::BufferObject
| ~BufferObject ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::BufferObject
static void | deleteBufferObject (unsigned int contextID, GLuint globj)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Types inherited from osg::BufferObject
typedef std::vector< BufferData * > | BufferDataList
typedef osg::buffered_object< osg::ref_ptr< GLBufferObject > > | GLBufferObjects
Protected Attributes inherited from osg::BufferObject
BufferObjectProfile | _profile
bool | _copyDataAndReleaseGLBufferObject
BufferDataList | _bufferDataList
GLBufferObjects | _glBufferObjects
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Constructor & Destructor Documentation

## AtomicCounterBufferObject() [1/2]

osg::AtomicCounterBufferObject::AtomicCounterBufferObject | ( |  | ) |

Referenced by AtomicCounterBufferObject(), and META_Object().

## AtomicCounterBufferObject() [2/2]

osg::AtomicCounterBufferObject::AtomicCounterBufferObject | ( | const AtomicCounterBufferObject & | ubo,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

References AtomicCounterBufferObject(), and osg::CopyOp::SHALLOW_COPY.

## ~AtomicCounterBufferObject()

virtual osg::AtomicCounterBufferObject::~AtomicCounterBufferObject | ( |  | ) |

protected virtual

## Member Function Documentation

## META_Object()

osg::AtomicCounterBufferObject::META_Object | ( | osg | ,
|  | AtomicCounterBufferObject | )

References AtomicCounterBufferObject().

The documentation for this class was generated from the following file:

- BufferObject